
/**
 * Klasse Warteschlange
 * 
 * @author claus albowski
 * @version Kursversion 4'11
 */
public class Warteschlange
{
    Listenelement kopf, schwanz; 

    /**
     * Konstruktor fuer Objekte der Klasse Warteschlange
     */
    public Warteschlange()
    {
        kopf=null;
        schwanz=null;
    }

    /**
     * ein Objekt stellt sich an.
     */
    public void anstellen(Object kunde){
        Listenelement neu =  new Listenelement(kunde);
        if (kopf==null) {
            kopf = neu;
            schwanz=neu;
        }
        else {
            schwanz.naechstes=neu;
            schwanz=neu;
        }
    }

    /**
     * bedienen laesst den ersten bearbeiten und
     * die Schlange aufruecken
     */
    public Object bedienen(){
        Object inhalt=null;
        if (!istLeer()) {
            inhalt=kopf.inhalt;
            kopf=kopf.naechstes;
            if (istLeer()) schwanz=null;
        }
        return inhalt;
    }

    /**
     * prueft, ob die Schlange leer ist.
     */
    public boolean istLeer(){
        return (kopf==null);
    }

    /**
     * interne Klasse Listenelement
     */
    private class Listenelement
    {
        private Object inhalt;
        private Listenelement naechstes;

        /**
         * Konstruktor fuer Objekte der Klasse Listenelement
         */
        public Listenelement(Object inhalt)
        {
            this.inhalt=inhalt;
            naechstes=null;
        }
    }
}
